// sharedmem.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "sharedmem.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//


// CsharedmemApp

BEGIN_MESSAGE_MAP(CsharedmemApp, CWinApp)
END_MESSAGE_MAP()


// CsharedmemApp construction

CsharedmemApp::CsharedmemApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance

	Map = NULL;
	Shared = NULL;
	Mutex = NULL;
	MapError = 0;
	SharedError = 0;
	MutexError = 0;
}


// The one and only CsharedmemApp object

CsharedmemApp theApp;

BOOL CsharedmemApp::Initialize(void)
{
  Map = ::CreateFileMapping(INVALID_HANDLE_VALUE,
	NULL,
	PAGE_READWRITE,
	0,
    SHARED_MEMORY_SIZE,
    _T("MicrotekRsxSharedMemory"));
  MapError = GetLastError();

  if(Map)
  {
    Shared = (char*)::MapViewOfFile(Map,FILE_MAP_WRITE,0,0,SHARED_MEMORY_SIZE);
    SharedError = GetLastError();
  }

  Mutex = ::CreateMutex(NULL,FALSE,_T("MicrotekRsxSharedMemoryMutex"));
  MutexError = GetLastError();

  if(!Map || !Shared || !Mutex)
    return(FALSE);

  return(TRUE);
}


// CsharedmemApp initialization
BOOL CsharedmemApp::InitInstance()
{
  CWinApp::InitInstance();

  char st[256];

  Initialize();

  return TRUE;
}

int CsharedmemApp::ExitInstance()
{
	// TODO: Add your specialized code here and/or call the base class

	if(Mutex)
      ::CloseHandle(Mutex);
	if(Shared)
      ::UnmapViewOfFile(Shared);
	if(Map)
      ::CloseHandle(Map);

	return CWinApp::ExitInstance();
}

char* CsharedmemApp::SharedMemoryPointer(void)
{
  return(Shared);
}

int CsharedmemApp::SharedMemorySize(void)
{
  if(Shared)
    return(SHARED_MEMORY_SIZE);
  return(0);
}


char* WINAPI GetSharedMemoryPointer(void)
{
  return(theApp.SharedMemoryPointer());
}

int WINAPI GetSharedMemorySize(void)
{
  return(theApp.SharedMemorySize());
}

